<?php
class sellsyOrders {
  /**
   *
   * @param int $order_id
   * @return array
   */

  static public function woocommerce_get_all_order_notes( $order_id ) {

  	$order_notes =	array();

  	$args = array (
  			'post_id' 	=> $order_id,
  			'orderby' 	=> 'comment_ID',
  			'order' 	=> 'DESC',
  			'approve' 	=> 'approve',
  			'type' 		=> 'order_note'
  	);

  	remove_filter ( 'comments_clauses', array (
  			'WC_Comments',
  			'exclude_order_comments'
  	), 10, 1 );

  	$notes = get_comments ( $args );
  	if ($notes) {
  		foreach ( $notes as $note ) {
        if ($note->comment_author !== 'WooCommerce') {
          $order_notes[] = strip_tags($note->comment_content);
        }
  		}
  	}
    return $order_notes;
  }

  static public function import_wc_orders_to_ssy() {
    // Temporary disabled
  	if (!isset($GLOBALS['ssy-langs']) || empty($GLOBALS['ssy-langs'])) {
  		$GLOBALS['ssy-langs'] = sellsyHelpers::get_langs();
  	}
    if ( !isset($GLOBALS['woo-ssy-custom-fields']) || empty($GLOBALS['woo-ssy-custom-fields']) ) {
      $GLOBALS['woo-ssy-custom-fields'] = sellsyHelpers::get_all_customfields();
    }
    // Check if there are new files
    $hooksDir = WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/files/';
    $files = scandir($hooksDir);
    if (empty($files)) {
      return false;
    }

    foreach ($files as $f) {
      if (strlen($f) < 5 ) {
        continue;
      }
      if (!strstr($f, 'order')) {
        continue;
      }
      // Move to exec
      rename($hooksDir . $f, WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f);
      // Get hook content
      $order_id = trim(file_get_contents(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f));
      self::generate_sellsy_order($order_id);


  		// Archive webhook file
  		unlink(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f);
    }

  }

  /*
   * Create WooCommerce Order into Sellsy
   * @param WooComemrce $order_id
   * @return Sellsy Document ID
   */
  static public function generate_sellsy_order( $order_id ) {
    global $wpdb;
    if ( !isset($GLOBALS['woo-ssy-custom-fields']) || empty($GLOBALS['woo-ssy-custom-fields']) ) {
      $GLOBALS['woo-ssy-custom-fields'] = sellsyHelpers::get_all_customfields();
    }
    if ( !isset($GLOBALS['woo-ssy-custom-fields']['id-woocommerce']) ) {
      $GLOBALS['woo-ssy-custom-fields']['id-woocommerce'] = sellsyHelpers::create_wooid_cf();
    }
    // Check if order already exists in Sellsy
    //
    $is_order_in_sellsy = sellsyHelpers::is_order_in_sellsy($order_id);
    if ($is_order_in_sellsy) {
     	// echo "Order already in Sellsy\n";
		return false;
    }


    // https://www.businessbloomer.com/woocommerce-easily-get-order-info-total-items-etc-from-order-object/
    $doctypes = get_option('woocommerce_sellsy_doctypes');
    $ssy_taxes = sellsyHelpers::get_taxes();
    $sync_roles = get_option('woocommerce_sellsy_roles');


    $order = wc_get_order( $order_id );
    
    $full_taxes = [];
    $taxTotals = $order->get_tax_totals();
    if (!empty($taxTotals)) {

	    foreach ($taxTotals as $tax) {
	      $fulltax = WC_Tax::_get_tax_rate($tax->rate_id);
	      $fulltax_rate = str_replace('.',',',round($fulltax['tax_rate'],1));
	      $taxTotals_id = isset($ssy_taxes[$fulltax_rate]) ? $ssy_taxes[$fulltax_rate] : false;

	      // Create new taxrate in Sellsy
	      if (!$taxTotals_id) {
					$createTax_r = array(
				    'method' => 'Accountdatas.createTaxe',
				    'params' => array(
				        'taxe' => array(
				            'name' => $fulltax['tax_rate_name'] . ' ' . $fulltax['tax_rate_country'],
				            'value' => $fulltax['tax_rate'],
				            'isEnabled' => 'Y'
				        )
				    )
					);
					$createTax = sellsyHelpers::runSellsy($createTax_r);

					if (isset($createTax->taxeid)) {
						$taxTotals_id = $createTax->taxeid;
					}
	      }
	      $full_taxes[$taxTotals_id] = $tax->amount;

	    }
    }
    else {
	    $taxTotals_id = $ssy_taxes["0"];
	    $full_taxes[$taxTotals_id] = "0";
	  }

    $shipping_total = $order->get_shipping_total();
    $shipping_tax = $order->get_shipping_tax();
    $shipping_method = $order->get_shipping_method();
    $shipping_taxrate = 0;
    $shipping_taxid = $taxTotals_id;

    if ($shipping_total > 0) {
      $shipping_taxrate = ($shipping_tax/$shipping_total)*100;

      /*
			echo "Shipping total:";
			echo '<pre>';
			print_r($shipping_total);
			echo '</pre>';
			echo "Shipping tax:";
			echo '<pre>';
			print_r($shipping_tax);
			echo '</pre>';
			echo "Shipping method:";
			echo '<pre>';
			print_r($shipping_method);
			echo '</pre>';

      echo "Shipping Taxrate: " . $shipping_taxrate . "<br />";
      */

      if (isset($ssy_taxes[$shipping_taxrate])) {
	      	$taxTotals_id = $ssy_taxes[$shipping_taxrate];
	    }
    }

    $createdDate = strtotime(explode(' ', $order->order_date)[0]);

    // Order details
    $order_data = $order->get_data();

    // Get meta data (to fill Sellsy custom fields)
    $order_meta_data = $order->get_meta_data();

    $discountAmount = '0';
    $discountUnit = 'amount';

    $ssy_services = sellsyHelpers::get_products('service');
    $fees = [];
    foreach( $order->get_items('fee') as $item_id => $item_fee ) {
      $fees[] = [
        'name' => $item_fee->get_name(),
        'total' => $item_fee->get_total(),
        'total_tax' => $item_fee->get_total_tax()
      ];
    }


    $coupons_list = array();
    $coupons = $order->get_used_coupons();
    if (!empty($coupons)) {
      foreach ($coupons as $c) {
        $_cp = new WC_Coupon($c);


        $coupons_list[] = $_cp->code;
        // $couponName = $_cp->code;
        //echo "Coupon: " . $_cp->discount_type . "  - " . $_cp->coupon_amount . "\n";


        if ($_cp->coupon_amount > 0) {
          $discountAmount = str_replace('%', '', $_cp->coupon_amount);
          $discountUnit = ($_cp->discount_type == 'fixed_cart') ? 'amount' : $_cp->discount_type;
        }
      }
    }


    $subject = 'Votre commande N°' . $order_id;

    // User
    // If customer_id = 0 => take email
    $customer_id = ($order_data['customer_id'] > 0) ? $order_data['customer_id'] : $order_data['billing']['email'];
    $client_ssy_id = sellsyThirds::checkThird($customer_id, $order_data);
    $client_ssy = sellsyHelpers::get_client($client_ssy_id);

    if (!$client_ssy_id) {
      echo "No Client Sellsy id\n";
      return false;
    }

    $ssy_billingAddress_id = false;
    $ssy_shippingAddress_id = false;
    $client_ssyAddresses = [
      'billing' => [],
      'shipping' => []
    ];
    if (!empty($client_ssy->address)) {
      foreach ($client_ssy->address as $addr) {
        if ($addr->isMain == 'Y') {

	        $ssy_billingAddress_id = $addr->id;
          $client_ssyAddresses['billing'] = $addr;
        }
        if ($addr->isMainDeliv == 'Y') {
          $ssy_shippingAddress_id = $addr->id;
          $client_ssyAddresses['shipping'] = $addr;
        }
      }
    }


    $sameAddresses = false;
    $client_billingAddress = [
      'forename' => $order->get_billing_first_name(),
      'name' => $order->get_billing_last_name(),
      'company' => $order->get_billing_company(),
      'part1' => $order->get_billing_address_1(),
      'part2' => $order->get_billing_address_2(),
      'town' => $order->get_billing_city(),
      'state' => $order->get_billing_state(),
      'zip' => $order->get_billing_postcode(),
      'countrycode' => $order->get_billing_country(),
      'isMain' => 'Y',
    ];
    $client_shippingAddress = [
      'forename' => $order->get_shipping_first_name(),
      'name' => $order->get_shipping_last_name(),
      'company' => $order->get_shipping_company(),
      'part1' => $order->get_shipping_address_1(),
      'part2' => $order->get_shipping_address_2(),
      'town' => $order->get_shipping_city(),
      'state' => $order->get_shipping_state(),
      'zip' => $order->get_shipping_postcode(),
      'countrycode' => $order->get_shipping_country(),
      'isMainDeliv' => 'Y',
    ];


    if ($client_shippingAddress['part1'] == $client_billingAddress['part1']) {
      $client_billingAddress['isMainDeliv'] = 'Y';
      $sameAddresses = true;
    }


    // If Client has no address in Sellsy > create
    if (empty($client_ssyAddresses)) {
      $ssy_billingAddress_id = sellsyHelpers::createAddress($client_billingAddress, $client_ssy_id);


      if (!$sameAddresses) {
        $ssy_shippingAddress_id = sellsyHelpers::createAddress($client_shippingAddress, $client_ssy_id);
      }
    }


    // If Sellsy billing address is different > Add new address
    if ($client_billingAddress['part1'] != $client_ssyAddresses['billing']->part1) {
      $ssy_billingAddress_id = sellsyHelpers::createAddress($client_billingAddress, $client_ssy_id);
    }


    // If Sellsy shipping address is different
    if ( ($client_shippingAddress['part1'] != $client_ssyAddresses['shipping']->part1)
    	&& ($client_shippingAddress['part1'] != $client_ssyAddresses['shipping']->part2)
    	) {
      if (!$sameAddresses) {
        $ssy_shippingAddress_id = sellsyHelpers::createAddress($client_shippingAddress, $client_ssy_id);
      }
    }


    $i = 0;
    $rows = [];

    foreach ($order->get_items() as $item_key => $item):
        $i++;
        ## Using WC_Order_Item methods ##


        // https://www.businessbloomer.com/woocommerce-easily-get-product-info-title-sku-desc-product-object/
        $item_id = $item->get_id();
        $product_id   = $item->get_product_id(); // the Product id
        $variation_id = $item->get_variation_id(); // the Variation id


        $item_type = $item->get_type(); // Type of the order item ("line_item")
        $item_name = $item->get_name(); // Name of the product


        $_pf = new WC_Product_Factory();
        $load_product_id = ($variation_id > 0) ? $variation_id : $product_id;
        $_product = $_pf->get_product($load_product_id);

        if (!$_product) {

	        continue;
        }


        $item_sku = $_product->get_sku();
        $quantity = $item->get_quantity();
        $tax_class = $item->get_tax_class();
        $line_subtotal = $item->get_subtotal(); // Line subtotal (non discounted)
        $line_subtotal_tax = $item->get_subtotal_tax(); // Line subtotal tax (non discounted)
        $line_total = $item->get_total(); // Line total (discounted)
        $line_total_tax = $item->get_total_tax(); // Line total tax (discounted)


        //$product_price = $line_total/$quantity;
        $product_price = $line_subtotal/$quantity;


        // Search in Sellsy products
        $ssy_product = ($product_id > 0) ? sellsyHelpers::is_product_in_sellsy($item_sku, 'item') : false;


        // Search in Sellsy services
        if (!$ssy_product) {
          $ssy_product = ($product_id > 0) ? sellsyHelpers::is_product_in_sellsy($item_sku, 'service') : false;
        }


        if (!$ssy_product && $product_id > 0) {

	        $ssy_product_id = sellsyProducts::push_product_to_sellsy($product_id, $_product, false);

	        $ssy_product = sellsyHelpers::get_product($ssy_product_id);
        }

        if ($ssy_product) {
          $tradename = $ssy_product->tradename;
          $taxrate = 0;
          if ($line_total > 0) {
            $taxrate = ($line_total_tax/$line_total)*100;
          }


          $rows[$i] = [
            'row_type' => 'item',
            'row_linkedid' => $ssy_product->id,
            'row_name' => $item_sku,
            'row_notes' => $ssy_product->notes,
            'row_unit' => $ssy_product->unit,
            //'row_unitAmount' => $product_price,
            'row_unitAmount' => "$product_price",
            'row_taxid' => $taxTotals_id,
            'row_qt' => $quantity,
            'row_purchaseAmount' => $ssy_product->purchaseAmount,
            //'row_accountingCode'	=> $ssy_product->accountingCode,
          ];
        }
        else {
          // echo "Product " . $item_name . " not in Sellsy\n";
          $rows[$i] = [
            'row_type'      => 'once',
            'row_name'      => $item_sku,
            'row_notes'     => $item_name,
            'row_unit'      => 'unité',
            //'row_unitAmount' => $product_price,
            'row_unitAmount' => "$product_price",
            'row_taxid'     => $taxTotals_id,
            'row_qt'        => $quantity,
          ];
        }

        if ($discountUnit == 'percent') {
          $rows[$i]['row_discount'] = $discountAmount;
          $rows[$i]['row_discountUnit'] = $discountUnit;
        }
    endforeach;


    if (!empty($shipping_method)) {
      $shipping_name = '';
      $shipping_method_id = reset( $order->get_shipping_methods() )->get_method_id();

			if ($shipping_method_id) {
	      $shipping_method_name = get_option('woocommerce_sellsy_carrier_' . $shipping_method_id);
				$shipping_name = (!empty($shipping_method_name)) ? explode('|', $shipping_method_name)[1] : '';


				if (!empty($shipping_name)) {

		      $rows[] = [
		        'row_type' => 'shipping',
		        //'row_shipping' => $shipping_method,
		        'row_shipping' => $shipping_name,
		        'row_notes'     => '',
		        'row_unitAmount' => "$shipping_total",
		        'row_taxid' => $shipping_taxid,
		        'row_qt' => 1,
		      ];
	      }
			}
    }

    if (!empty($fees)) {
      foreach ($fees as $fee) {
        $hasService = false;
        $taxFees = ($fee['total_tax']/$fee['total'])*100;

        //echo "Fee name: " . $fee['name'] . "\n";
        foreach ($ssy_services as $name => $serv) {
          // pr($serv);
          if (strtolower($serv->tradename) ==  strtolower($fee['name'])) {
            $hasService = true;
            $linked = $serv;
          }
        }


        if ($hasService) {
					$feesAmount = $fee['total'];
          $rows[] = [
            'row_type' => 'item',
            'row_linkedid' => $linked->id,
            'row_name' => $linked->name,
            'row_notes' => $linked->tradename,
            'row_unitAmount' => "$feesAmount",
            'row_taxid' => $ssy_taxes[$taxFees],
            'row_qt' => 1,
          ];
        }
        else {
	        $feesAmount = $fee['total'];
          $rows[] = [
            'row_type' => 'once',
            'row_name' => $fee['name'],
            'row_notes' => '',
            'row_unitAmount' => "$feesAmount",
            'row_taxid' => $ssy_taxes[$taxFees],
            'row_qt' => 1,
          ];
        }
      }
    }

    $ht_total = $order->get_total()-$order->get_total_tax();

    $parentId = 0;
    foreach ($doctypes as $doctype):
        $createDoc_r = [
         'method' => 'Document.create',
         'params' => [
            'document' => [
                'doctype' => $doctype,
                'thirdid' => $client_ssy_id,
                'subject' => $subject,
                'displayShipAddress' => 'N',
                //'showContactOnPdf' => 'Y',
                //'doclayout' => $layout,
                'displayedDate' => $createdDate,
                'notes' => $order_data['customer_note'],
                'tags' => "WooCommerce > Sellsy",
      		      // 'payMediums' => unserialize($thirdPrefs->payMediums),
                'overrideTotals' => true,
                'overrideTotalsData' => [
                  'totalTaxesFree' => $ht_total,
                  'tax' => $full_taxes,
                  'totalAllInc' => $order->get_total(),
                ],
            ],
            'row' => $rows,
          ]
        ];

        if ($parentId > 0) {
          $createDoc_r['params']['document']['parentId'] = $parentId;
        }

        if ($ssy_shippingAddress_id) {
          $createDoc_r['params']['thirdaddress'] = [
            'id' => $ssy_billingAddress_id
          ];
        }
        if ($ssy_shippingAddress_id) {
          $createDoc_r['params']['shipaddress'] = [
            'id' => $ssy_shippingAddress_id
          ];
        }


        if ($discountAmount > 0 && $discountUnit == 'amount') {
          $createDoc_r['params']['globalDiscount'] = $discountAmount;
          $createDoc_r['params']['globalDiscountUnit'] = $discountUnit;
        }


		if ($order->is_paid() || $order->has_status('processing') || $order->has_status('completed')) {

			echo "Order is paid<br />";

		}
		else {
			echo "Order is NOT paid<br />";
		}

		echo "<pre>";
		print_r($createDoc_r);
		echo "</pre>";
		die;

        $createDoc = sellsyHelpers::runSellsy($createDoc_r);
        if (!isset($createDoc->doc_id)) {
          return false;
        }

        $doc_id = $createDoc->doc_id;
        $parentId = $doc_id;

        $cfs_datas = [
          ['cfid' => $GLOBALS['woo-ssy-custom-fields']['id-woocommerce'], 'value' => $order_id],
        ];
        $cfs = sellsyHelpers::save_CustomFields('document', $doc_id, $cfs_datas);

        if ($doctype == 'invoice') {
			// If Draft numerotation is enabled
			$draftNumerotation = sellsyHelpers::runSellsy([
				'method' => 'Document.getNumberingDraftStatus',
				'params' => []
			]);
			if ($draftNumerotation->enabled == 'Y')
			{
				// Validate invoice before
				sellsyHelpers::runSellsy([
					'method' => 'Document.validate',
					'params' => [
						'docid' => $doc_id
					]
				]);
			}

            // Create payment
	        if ($order->is_paid() || $order->has_status('processing') || $order->has_status('completed'))
			{
	            $payment = sellsyHelpers::createPayment([
	              'date' => $createdDate,
	              'amount' => $order->get_total(),
	              'ident' => $order->get_transaction_id(),
	              'notes' => $order_id,
	              'docid' => $doc_id,
	              'doctype' => $doctype
	            ]);
			}

            // Send proforma bby email to client
            $sendInvoice = get_option('woocommerce_sellsy_send_invoice');
            if ($sendInvoice == 'yes') {
                $customer = get_userdata($order_data['customer_id']);
                $customer_email = isset($customer->data->user_email) ? $customer->data->user_email : $order_data['billing']['email'];
                $sendEmail_r =  array(
                  'method' => 'Document.sendDocByMail',
                  'params' => array (
                    'docid' => $doc_id,
                    'email' => array(
                      'doctype' => $doctype,
                      'emails' => [$customer_email],
                      //'emails' => ['anna.renaudin@gmail.com'],
                    ),
                  ),
                );
                $sendEmail = sellsyHelpers::runSellsy($sendEmail_r);
            }
        }

    endforeach;

  }

}
?>
