<?php
class sellsyProducts {


  /*
   * Get WooCommerce new product and push it to Sellsy
   */
  static public function import_wc_product_to_ssy() {
  	// if (!isset($GLOBALS['ssy-langs']) || empty($GLOBALS['ssy-langs'])) {
  	// 	$GLOBALS['ssy-langs'] = sellsyHelpers::get_langs();
  	// }

    if ( !isset($GLOBALS['woo-ssy-custom-fields']) || empty($GLOBALS['woo-ssy-custom-fields']) ) {
      $GLOBALS['woo-ssy-custom-fields'] = sellsyHelpers::get_all_customfields();
    }


    $logs = '';


    // Check if there are new files
    $hooksDir = WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/files/';
    $files = scandir($hooksDir);
    if (empty($files)) {
      return false;
    }

    // Import all products
    foreach ($files as $f) {

      if (strlen($f) < 5) {
        continue;
      }

      if (!strstr($f, 'catalog')) {
        continue;
      }

      // Move to exec
      rename($hooksDir . $f, WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f);


      $loop = new WP_Query([
        'post_type' => 'product',
        'posts_per_page' => -1,
      ]);

      $loop = new WP_Query([
        'post_type' => 'product',
        'posts_per_page' => -1,
      ]);


      while ( $loop->have_posts() ) : $loop->the_post();
          global $post;
          if (!$post) {
            return;
          }

          $product = wc_get_product( $post->ID );
          self::push_product_to_sellsy($post->ID, $product, false);

      endwhile;

      wp_reset_query();

      unlink(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f);
    }


    // Import each new product
    foreach ($files as $f) {

      if (strlen($f) < 5) {
        continue;
      }


      if (!strstr($f, 'item')) {
        continue;
      }

      // Move to exec
      rename($hooksDir . $f, WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f);


      // Get hook content
      $product_id = trim(file_get_contents(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/hooks/exec/' . $f));
      $product = wc_get_product( $product_id );

      if (!$product) {
        return;
      }

      self::push_product_to_sellsy($product_id, $product, false);
    }
  }

  /*
   * Import all categories from WooCommerce to Sellsy
   */


  static public function import_all_categories_from_wc_to_ssy() {

    $product_categories = get_formatted_wc_categories();

    // Import all categories from Woo to Sellsy
    foreach ($product_categories as $cat)
    {
        $createCategory_r = array(
          'method' => 'Catalogue.createCategory',
          'params' => array (
            'category' => array(
              'name' => $cat['name'],
              'description' => '',
            ),
          )
        );
        $createCategory = sellsyHelpers::runSellsy($createCategory_r);
        $ssy_cat_id = $createCategory->response->id;
        // echo strtoupper($createSubcategory->status). " Create " . $cat['name'] . "\n";

        if (!empty($cat['children'])) {
          foreach ($cat['children'] as $subcat)
          {
              $createSubcategory_r = array(
                'method' => 'Catalogue.createCategory',
                'params' => array (
                  'category' => array(
                    'name' => $subcat['name'],
                    'description' => '',
                    'parentid' => $ssy_cat_id,
                  ),
                )
              );
              $createSubcategory = sellsyHelpers::runSellsy($createSubcategory_r);

              // echo "   " . strtoupper($createSubcategory->status). " . Create " . $subcat['name'] . "\n";
          }
        }
    }
  }

  static public function get_formatted_wc_categories() {
      $product_categories = array();
      $all_product_categories = get_terms('product_cat', $cat_args = [
        'orderby'    => 'asc',
        'order'      => 'name',
        'hide_empty' => false,
      ]);

      if (empty($all_product_categories)) { return []; }

      foreach ($all_product_categories as $key => $category)
      {
          if ($category->parent == 0) {
              $product_categories[$category->term_id] = [
                'name' => $category->name,
                'children' => [],
              ];
          }
      }

      foreach ($all_product_categories as $key => $category)
      {
          if ($category->parent > 0) {

              $product_categories[$category->parent]['children'][$category->term_id] = [
                'name' => $category->name,
              ];
          }
      }

      return $product_categories;
  }


  static public function enable_ssy_send_to_woo() {

    if ( !isset($GLOBALS['woo-ssy-custom-fields']) || empty($GLOBALS['woo-ssy-custom-fields']) ) {


      $GLOBALS['woo-ssy-custom-fields'] = sellsyHelpers::get_all_customfields();
    }

    $products = sellsyHelpers::get_products();
    if (empty($products)) {
      return;
    }


    foreach ($products as $product) {

      $woo_item_id = wc_get_product_id_by_sku($product->name);
      $sendToWoo = (!$woo_item_id) ? 'Non' : 'Oui';
      $datas = [
        ['cfid' => $GLOBALS['woo-ssy-custom-fields']['envoi-woocommerce'], 'value' => $sendToWoo]
      ];

      $saveCfs = sellsyHelpers::save_CustomFields('item', $product->id, $datas);
      //// echo "ID: " . $product->id . " | " . $sendToWoo . " | " . $saveCfs->status . "<br />";
    }

    $services = sellsyHelpers::get_products('service');

    if (empty($services)) {
      return;
    }
    foreach ($services as $service) {
      $woo_item_id = wc_get_product_id_by_sku($service->name);
      $sendToWoo = (!$woo_item_id) ? 'Non' : 'Oui';
      $datas = [
        ['cfid' => $GLOBALS['woo-ssy-custom-fields']['envoi-woocommerce'], 'value' => $sendToWoo]
      ];

      $saveCfs = sellsyHelpers::save_CustomFields('item', $service->id, $datas);

      //// echo "ID: " . $product->id . " | " . $sendToWoo . " | " . $saveCfs->status . "<br />";
    }

    return;
  }


  // testing
  // Get all Sellsy products, check if one is missing in WooCommerce
  static public function check_ssy_products_in_wc() {


    $ssy_products = sellsyHelpers::get_products();

    foreach ($ssy_products as $product) {
      $woo_item_id = wc_get_product_id_by_sku($product->name);
      if (!$woo_item_id) {
          // echo "Sellsy Product NOT in Woo\n";
  	      return false;
      }
    }
  }

  // add_action( 'save_post_product', 'push_product_to_sellsy', 10, 3 );
  static public function push_product_to_sellsy( $post_id, $post, $update ) {
    global $wpdb;

    if ( !isset($GLOBALS['woo-ssy-custom-fields']) || empty($GLOBALS['woo-ssy-custom-fields']) ) {
      $GLOBALS['woo-ssy-custom-fields'] = sellsyHelpers::get_all_customfields();
    }

    $ssy_item_id = self::create_product($post_id);


    return $ssy_item_id;
  }

    static public function create_product($woo_item_id) {

    	  if (!isset($GLOBALS['custom_fields'])) {
    			$GLOBALS['custom_fields'] = sellsyHelpers::get_all_customfields();
    	  }

       // $unitid = (isset($GLOBALS['units'][$datas['unite_de_vente']])) ? $GLOBALS['units'][$datas['unite_de_vente']] : false;
       $_pf = new WC_Product_Factory();
       $_product = $_pf->get_product($woo_item_id);


			 if ($_product->is_type('simple')) {
		         return self::create_simple_product($_product, $woo_item_id);
			 }
		
			 if ($_product->is_type('variable')) {
		         return self::create_variable_product($_product, $woo_item_id);
			 }
    }

    static public function get_WooTaxrate($_product) {
       $taxrate = '20';
       $tax_rates = WC_Tax::get_rates($_product->get_tax_class());
       if (!empty($tax_rates)) {
         $tax_rates = reset($tax_rates);
         $taxrate = $tax_rates['rate'];
       }

    		 return $taxrate;
    }

    static public function get_WooCategory($_product) {

    			$categoryid = false;
    			$product_categories_ids = $_product->get_category_ids();
    			if (!empty($product_categories_ids)) {
    			  $full_category = get_term($product_categories_ids[0]);
    			  $category_name = $full_category->name;
    			  $categoryid = sellsyHelpers::get_category($category_name);
    			}

    			return $categoryid;
    }

    static public function create_simple_product($_product, $woo_item_id) {

    		  $taxrate = self::get_WooTaxrate($_product);
    		  $categoryid = self::get_WooCategory($_product);

    			$is_already_in_ssy = sellsyHelpers::is_product_in_sellsy($_product->get_sku(), true);

    			$purchase = ($is_already_in_ssy) ? $is_already_in_ssy->purchaseAmount : 0;
    			$method = ($is_already_in_ssy) ? 'update' : 'create';
    			$request = [
    			 'method' => 'Catalogue.' . $method,
    			 'params' => [
    			   'type' => 'item',
    			   'item' => [
    			      'name' => $_product->get_sku(),
    			      'tradename' => $_product->get_name(),
    			      'tradenametonote'   => 'N',
    			      'notes' => $_product->get_name() . ' ' . strip_tags($_product->get_description()),
    			      'unitAmount' => $_product->get_regular_price(),
    			      'unit' => 'unité',
    			      'qt' => 1,
    			      'purchaseAmount' => $purchase,
    			      'unitAmountIsTaxesFree' => 'Y',
    			      'categoryid' => $categoryid,
    			      'taxrate' => $taxrate,
    			      'characteristics'   => array(
    			        'width' => $_product->get_width(),
    			        'length' => $_product->get_length(),
    			        'height' => $_product->get_height(),
    			        'weight' => $_product->get_weight(),
    			      )
    			   ]
    			 ]
    			];
    			if ($is_already_in_ssy) {
    			 $request['params']['id'] = $is_already_in_ssy->id;
    			}
					
    			$response = sellsyHelpers::runSellsy($request);
    			if (!$response) {
    			  return;
    			}
    			
    			$ssy_item_id = $response->item_id;
    			echo strtoupper($response->status) . " " . $method . " product " . $ssy_item_id . "\n";

    			//update_field('id_sellsy', $ssy_item_id, $is_already_in_ssy);
    			update_post_meta($woo_item_id, '_id_sellsy', $ssy_item_id);

    			if ($method == 'create') {

    			  // Picture
    			  //$image = dirname(__FILE__) . '/files/product.jpg';
    			  $image = wp_get_attachment_image_src( get_post_thumbnail_id($woo_item_id), 'single-post-thumbnail' );

    			  if (!empty($image)) {
    			    $dir = wp_upload_dir();

    			    $image_path = str_replace(site_url(), '', $image[0]);
    			    $image_path = str_replace('/wp-content/uploads', $dir['basedir'], $image_path);
    			  }

    			  if (file_exists($image_path))
    			  {
    			      $addPicture_r = array(
    			          'method' => 'Catalogue.addPictureToGallery',
    			          'params' => array (
    			            'id' => "$ssy_item_id",
    			          )
    			      );
    			      $requestFile = [
    			          "type" => mime_content_type($image_path),
    			          "name" => basename($image[0]),
    			          "tmp_name" => $image_path,
    			      ];

    			      $addPicture = sellsyConnect_curl::load()->requestApi($addPicture_r,$requestFile);

    			      if ($addPicture->status !== 'success')
    			      {
    			          echo "ERROR picture " . $service_id . "\n";
    			          echo "<pre>" . print_r($addPicture, true) . "</pre><pre>" . print_r($addPicture_r, true) . "</pre><pre>" . print_r($requestFile, true) . "</pre>";
    			      }
    			  }
    			}

    			if ( !$ssy_item_id ) {
    			  return false;
    			}

    			$cfs = sellsyHelpers::save_CustomFields('item', $ssy_item_id, [
    			 ['cfid' => $GLOBALS['custom_fields']['woocommerceid'], 'value' => $woo_item_id],
    			]);
    }

    static public function create_variable_product($_product, $woo_item_id) {

    			$_pf = new WC_Product_Factory();

    		  $taxrate = self::get_WooTaxrate($_product);
    		  $categoryid = self::get_WooCategory($_product);

    			$wooVariations = $_product->get_available_variations();

    			if (empty($wooVariations)) {
    				return false;
    			}

    			foreach ($wooVariations as $var) {

    					$variation_woo_id = $var['variation_id'];

    					$variation = $_pf->get_product($variation_woo_id);
    					$is_already_in_ssy = sellsyHelpers::is_product_in_sellsy($variation->get_sku(), true);

    					$purchase = ($is_already_in_ssy) ? $is_already_in_ssy->purchaseAmount : 0;
    					$method = ($is_already_in_ssy) ? 'update' : 'create';
    					$request = [
    					 'method' => 'Catalogue.' . $method,
    					 'params' => [
    					   'type' => 'item',
    					   'item' => [
    					      'name' => $variation->get_sku(),
    					      'tradename' => $variation->get_name(),
    					      'tradenametonote'   => 'N',
    					      'notes' => $variation->get_name() . ' ' . strip_tags($variation->get_description()),
    					      'unitAmount' => $variation->get_regular_price(),
    					      'unit' => 'unité',
    					      'qt' => 1,
    					      'purchaseAmount' => $purchase,
    					      'unitAmountIsTaxesFree' => 'Y',
    					      'categoryid' => $categoryid,
    					      'taxrate' => $taxrate,
    					      'characteristics'   => array(
    					        'width' => $_product->get_width(),
    					        'length' => $_product->get_length(),
    					        'height' => $_product->get_height(),
    					        'weight' => $_product->get_weight(),
    					      )
    					   ]
    					 ]
    					];
    					if ($is_already_in_ssy) {
    						$request['params']['id'] = $is_already_in_ssy->id;
    					}

					
    					$response = sellsyHelpers::runSellsy($request);

    					if (!$response) {
    					  return;
    					}
    					$ssy_item_id = $response->item_id;

    					//update_field('id_sellsy', $ssy_item_id, $is_already_in_ssy);
    					update_post_meta($variation_woo_id, '_id_sellsy', $ssy_item_id);

    					if ($method == 'create') {

    					  // Picture
    					  //$image = dirname(__FILE__) . '/files/product.jpg';
    					  $image = wp_get_attachment_image_src( get_post_thumbnail_id($woo_item_id), 'single-post-thumbnail' );

    					  if (!empty($image)) {
    					    $dir = wp_upload_dir();

    					    $image_path = str_replace(site_url(), '', $image[0]);
    					    $image_path = str_replace('/wp-content/uploads', $dir['basedir'], $image_path);
    					  }

    					  if (file_exists($image_path))
    					  {
    					      $addPicture_r = array(
    					          'method' => 'Catalogue.addPictureToGallery',
    					          'params' => array (
    					            'id' => "$ssy_item_id",
    					          )
    					      );
    					      $requestFile = [
    					          "type" => mime_content_type($image_path),
    					          "name" => basename($image[0]),
    					          "tmp_name" => $image_path,
    					      ];

    					      $addPicture = sellsyConnect_curl::load()->requestApi($addPicture_r,$requestFile);

    					      if ($addPicture->status !== 'success')
    					      {
    					          echo "ERROR picture " . $service_id . "\n";
    					          echo "<pre>" . print_r($addPicture, true) . "</pre><pre>" . print_r($addPicture_r, true) . "</pre><pre>" . print_r($requestFile, true) . "</pre>";
    					      }
    					  }
    					}

    					if ( !$ssy_item_id ) {
    					  return false;
    					}

    					$cfs = sellsyHelpers::save_CustomFields('item', $ssy_item_id, [
    					 ['cfid' => $GLOBALS['custom_fields']['woocommerceid'], 'value' => $variation_woo_id],
    					]);
    			}
		}

  static public function check_category($ssyProduct) {
    $wc_category_id = false;
    if (!empty($ssyProduct->categories)) {
      foreach ($ssyProduct->categories as $category) {
        if ($category->id !== $ssyProduct->categoryid) {
          continue;
        }

        if ( !term_exists($category->name, 'product_cat') ) {
          $term = wp_insert_term($category->name, 'product_cat');
          $wc_category_id = $term['term_id'];
          break;
        }

        $term_s = get_term_by( 'name', $category->name, 'product_cat' );
        $wc_category_id = $term_s->term_id;
      }
    }

    return $wc_category_id;
  }


  // Check Sellsy stocks and update WooCommerce
  static public function import_ssy_stocks_to_wc()
  {

		$products = sellsyHelpers::get_products();

		if (empty($products)) {
			echo "No product found in Sellsy";
			return;
		}

		foreach ($products as $product) {
				echo "Product " . $product->id . " - ";

			// Skip line if product stock is disabled
			if ($product->stockEnabled == false) {
			  echo "Stock is disabled<br />";
			  continue;
			}
			$stockSellsy = round($product->stockItemQt,0);


			// Search Woo product by $product->name
			$wooProduct = self::get_product_by_sku($product->name);
			if (is_null($wooProduct)) {
			  echo "Product " . $product->name . " not found in Woo\n";
				$getWooVariations = array(
			    'post_type'  => 'product_variation',
			    'meta_query' => array(
		        array(
		          'key'   => '_sku',
		          'value' => $product->name,
		        )
			    )
				);
				$wooVariations = get_posts($getWooVariations);

				if (empty($wooVariations)) {
					continue;
				}
			}

			if (!is_null($wooProduct)) {
				// Check if woo stock is enabeld
				$woo_id = $wooProduct->get_id();
				$isStockEnabled = get_post_meta($woo_id, "_manage_stock")[0];

				if ($isStockEnabled !== 'yes') {
				  update_post_meta($woo_id, "_manage_stock", "yes");
				}

				// Compare stocks
				$stockWoo = $wooProduct->get_stock_quantity();


				// If stocks are different, set woo stock with sellsy stock value
				if ((int) $stockWoo !== (int) $stockSellsy) {
					echo "Product " . $product->name . " has different stocks: Sellsy: " . $stockSellsy . " (" . $product->id . ") | Woo " . $stockWoo . " (" . $wooProduct->get_id() . ")<br />";
					echo "Le stock du produit référence " . $product->name . " doit être mis à jour - Nouveau stock (issu de Sellsy) " . $stockSellsy . " | Woo ID " . $wooProduct->get_id() . "<br />";
				  update_post_meta($woo_id, '_stock', $stockSellsy);

				  $stockStatus = ($stockSellsy > 0) ? 'instock' : 'outofstock';
				  update_post_meta($woo_id, '_stock_status', wc_clean($stockStatus));
					echo "Set stock status to " . $stockStatus . "<br />";
				}
			}

			if (!empty($wooVariations)) {

				foreach ($wooVariations as $variation)
				{
						$woo_id = $variation->ID;
						$isStockEnabled = get_post_meta($woo_id, "_manage_stock")[0];

						if ($isStockEnabled !== 'yes') {
						  update_post_meta($woo_id, "_manage_stock", "yes");
						}

						update_post_meta($woo_id, '_stock', $stockSellsy);

						$stockStatus = ($stockSellsy > 0) ? 'instock' : 'outofstock';
						update_post_meta($woo_id, '_stock_status', wc_clean($stockStatus));

						echo "Set stock status to " . $stockStatus . " for variation " . $woo_id . " (" . $product->name . ")<br />";
				}
			}
		}
  }

	static public function get_productType($product_id) {
			global $wpdb;
      // Get type (product or variation)
      $sql2 = "SELECT pm.post_type FROM ".$wpdb->prefix."posts AS pm WHERE pm.ID='" . $product_id . "'";

			return $wpdb->get_var($sql2);
	}

  static public function get_product_by_sku( $sku ) {

    global $wpdb;


    $sql = "SELECT pm.post_id
    				FROM ".$wpdb->postmeta." AS pm
    				WHERE pm.meta_key='_sku' AND pm.meta_value='%s'";
    $product_id = $wpdb->get_var($wpdb->prepare($sql, $sku));

    if ( $product_id ) {

      // Get type (product or variation)
      $sql2 = "SELECT pm.post_type FROM ".$wpdb->prefix."posts AS pm WHERE pm.ID='" . $product_id . "'";
      $product_type = $wpdb->get_var($wpdb->prepare($sql2, $sku));

      if ($product_type == 'product') {
        return new WC_Product( $product_id );
      }

      if ($product_type == 'variation') {
        return WC_Product_Variation($product_id);
      }
    }

    return false;
  }


  /*
   * Import all products from WooCommerce to Sellsy
   */


  static public function import_all_products_from_wc_to_ssy() {

  		$loop = new WP_Query([
        'post_type' => 'product',
  			'posts_per_page' => -1
      ]);


  		if ( $loop->have_posts() ) {
        // echo "Count: " . $loop->post_count . "\n";
  			while ( $loop->have_posts() ) : $loop->the_post();
          self::push_product_to_sellsy(get_the_ID());
  			endwhile;

  		}
  }

}
