<?php
// On plugin activation > add hourly cron to push sellsy products to woocommerce
register_activation_hook(__FILE__, 'set_wc_to_sellsy_activation');

/*
function wc_to_ssy_wp_cron_admin_notice() {
  if (DISABLE_WP_CRON)
  {
     echo '<div class="notice notice-error">
            <p><strong>WooCommerce to Sellsy &bull; WP CRON</strong><br />WP CRON a été désactivé sur votre installation, ce qui peut empêcher cette mise à jour de se terminer. Il doit impérativement être activé pour faire fonctionner le plugin WooCommerce to Sellsy.</p>
          </div>';
     // Vous pouvez exécuter manuellement les mises à jour de la file d’attente ici.
  }
}

add_action('admin_notices', 'wc_to_ssy_wp_cron_admin_notice');
*/
// On plugin activation > Add crons
function set_wc_to_sellsy_activation() {
  // Check
  // Check crons
  // $cron_jobs = get_option( 'cron' );
  // var_dump($cron_jobs);

  // Enable all crons
  if (! wp_next_scheduled ( 'cron_import_wc_product_to_ssy' )) {
    wp_schedule_event(time(), 'hourly', 'cron_import_wc_product_to_ssy');
  }

  if (! wp_next_scheduled ( 'cron_import_wc_thirds_to_ssy' )) {
    wp_schedule_event(time(), 'hourly', 'cron_import_wc_thirds_to_ssy');
  }

	if (! wp_next_scheduled ( 'cron_import_wc_orders_to_ssy' )) {
    wp_schedule_event(time(), 'hourly', 'cron_import_wc_orders_to_ssy');
  }

  // if (! wp_next_scheduled ( 'cron_import_wc_stocks_to_ssy' )) {
  //   wp_schedule_event(time(), 'hourly', 'cron_import_wc_stocks_to_ssy');
  // }
}


add_action('cron_import_wc_product_to_ssy', 'import_wc_product_to_ssy');
add_action('cron_import_wc_orders_to_ssy', 'import_wc_orders_to_ssy');
add_action('cron_import_wc_thirds_to_ssy', 'import_wc_thirds_to_ssy');
//add_action('cron_import_wc_stocks_to_ssy', 'import_wc_stocks_to_ssy');

add_action( 'admin_init', 'set_wc_to_sellsy_activation' );

// On plugin deactivation > Clear hourly cron (to push sellsy products to woocommerce)
register_deactivation_hook( __FILE__, 'unset_wc_to_sellsy_activation' );


function unset_wc_to_sellsy_activation() {
  wp_clear_scheduled_hook( 'cron_import_wc_product_to_ssy' );
  wp_clear_scheduled_hook( 'cron_import_wc_thirds_to_ssy' );
	wp_clear_scheduled_hook( 'cron_import_wc_orders_to_ssy' );
  //wp_clear_scheduled_hook( 'cron_import_wc_stocks_to_ssy' );
}

// Cron Import product from Sellsy to WooCommerce
function import_wc_product_to_ssy() {
	return sellsyProducts::import_wc_product_to_ssy();
}

function import_wc_thirds_to_ssy() {
  return sellsyThirds::import_wc_thirds_to_ssy();
}

// Cron Import orders from WooCommerce to Sellsy
function import_wc_orders_to_ssy() {
	return sellsyOrders::import_wc_orders_to_ssy();
}

// Cron Import product from Sellsy to WooCommerce
// function import_wc_stocks_to_ssy() {
//   return sellsyProducts::import_wc_stocks_to_ssy();
// }
