<?php
/**
 * Settings page
 *
 */
function woocommerce_sellsy_register_settings() {

	// Api Group
	//
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_api_consumer_token', array('default' => get_option('woocommerce_sellsy_api_consumer_token')) );
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_api_consumer_secret', array('default' => get_option('woocommerce_sellsy_api_consumer_secret')) );
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_api_access_token', array('default' => get_option('woocommerce_sellsy_api_access_token')) );
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_api_access_secret', array('default' => get_option('woocommerce_sellsy_api_access_secret')) );


	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_owner', array('default' => get_option('woocommerce_sellsy_owner')) );
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_doctypes', array('default' => ['order']) );
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_roles', array('default' => ['customer']) );
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_send_invoice', array('default' => 'no') );

	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_woo_order_status', array('default' => 'completed') );

	$wooShippingOption = get_option( 'woocommerce_ship_to_countries' );
	if ($wooShippingOption !== 'disabled') {

	  $shipping_methods = WC()->shipping->load_shipping_methods();

	  foreach ($shipping_methods as $ship => $method) {

	  	if ($method->enabled !== 'yes') { continue; }

			register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_carrier_' . $method->id, array('default' => get_option('woocommerce_sellsy_carrier_' . $method->id)) );
	  }
	}

	// Debug
	//
	register_setting( 'woocommerce_sellsy_settings', 'woocommerce_sellsy_debug_email', array('default' => '') );

	add_filter('plugin_action_links_'.plugin_basename(__FILE__), 'custom_add_plugin_page_settings_link');
	function custom_add_plugin_page_settings_link( $links ) {
		$links[] = '<a href="' .
			admin_url( 'options-general.php?page=woocommerce_selly' ) .
			'">' . __('Settings') . '</a>';
		return $links;
	}
}

add_action( 'admin_init', 'woocommerce_sellsy_register_settings' );
function woocommerce_sellsy_register_options_page() {
	add_options_page('WooCommerce to Sellsy Réglages', 'Woocommerce to Sellsy', 'manage_options', 'woocommerce_selly', 'woocommerce_sellsy_options_page');
}

add_action('admin_menu', 'woocommerce_sellsy_register_options_page');
function add_woocommerce_sellsy_options_style() {
  wp_register_style('options_page_style', plugins_url('assets/css/style.css',__FILE__));
  wp_enqueue_style('options_page_style');
}

add_action( 'admin_menu', 'add_woocommerce_sellsy_options_style' );
function woocommerce_sellsy_options_page() {
	  wp_register_style('options_page_style', plugins_url('assets/css/bootstrap.min.css',__FILE__));
	  wp_enqueue_style('options_page_style');

		$checkApi = sellsyHelpers::checkApi();
		$doctypes = get_option('woocommerce_sellsy_doctypes');
		$sync_roles = get_option('woocommerce_sellsy_roles');
		
		$wooShippingOption = get_option( 'woocommerce_ship_to_countries' );
		$shipping_methods = WC()->shipping->load_shipping_methods();
		  if ($checkApi) {
		  		$GLOBALS['woo-ssy-custom-fields'] = sellsyHelpers::get_all_customfields();
		  		if ( !empty($GLOBALS['woo-ssy-custom-fields']) ) {

	    		if ( !isset($GLOBALS['woo-ssy-custom-fields']['id-woocommerce']) ) {

	    			$cf_wooId = sellsyHelpers::create_wooid_cf();

	    		}
		}
    }
	  if ($wooShippingOption !== 'disabled') {
	  	$ssy_carriers = sellsyHelpers::get_shippings();
	  }
	  ?>
	  <div class="page page-custom">
	  		<img src="<?php echo WOOCOMMERCE_SELLSY_PLUGIN_URL; ?>/assets/images/logo-selsy-300.png" alt="Sellsy" width="75" height="auto" />
	      <h1 class="h1">WooCommerce to Sellsy</h1>
	      Les éléments suivants seront synchronisés avec votre compte :
	      <ul class="list">
	      	<li>les clients WooCommerce seront déversés dans Sellsy <span class="matching-key">Clé de reconnaissance : adresse email</span></li>
	      	<li>les produits WooCommerce seront déversés dans Sellsy <span class="matching-key">Clé de reconnaissance : UGS WooCommerce | Référence Sellsy</span></li>
	      	<li>les commandes WooCommerce seront déversées dans Sellsy</li>
	      </ul>
	      <form method="post" action="options.php" class="form">
	          <?php settings_fields( 'woocommerce_sellsy_settings' ); ?>
	          <?php do_settings_sections( 'woocommerce_sellsy_settings' ); ?>
	          <div class="section">
	              <h2>Tokens API Sellsy</h2>
	              <p>A régler depuis votre compte Sellsy. Réglages > Développeurs</p>
	              <table cellpadding="5" cellspacing="5">
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_api_consumer_token">Consumer token</label></th>
	                      <td><input type="text" id="woocommerce_sellsy_api_consumer_token" name="woocommerce_sellsy_api_consumer_token" value="<?php echo get_option('woocommerce_sellsy_api_consumer_token'); ?>" style="width: 400px;" /></td>
	                  </tr>
	                  <tr valign="top">
	                      <th align="left" scope="row"><label for="woocommerce_sellsy_api_consumer_secret">Consumer secret</label></th>
	                      <td><input type="password" id="woocommerce_sellsy_api_consumer_secret" name="woocommerce_sellsy_api_consumer_secret" value="<?php echo get_option('woocommerce_sellsy_api_consumer_secret'); ?>" style="width: 400px;" /></td>
	                  </tr>
	                  <tr valign="top">
	                      <th align="left" scope="row"><label for="woocommerce_sellsy_api_access_token">Utilisateur token</label></th>
	                      <td><input type="text" id="woocommerce_sellsy_api_access_token" name="woocommerce_sellsy_api_access_token" value="<?php echo get_option('woocommerce_sellsy_api_access_token'); ?>" style="width: 400px;" /></td>
	                  </tr>
	                  <tr valign="top">
	                      <th align="left" scope="row"><label for="woocommerce_sellsy_api_access_secret">Utilisateur secret</label></th>
	                      <td><input type="password" id="woocommerce_sellsy_api_access_secret" name="woocommerce_sellsy_api_access_secret" value="<?php echo get_option('woocommerce_sellsy_api_access_secret'); ?>" style="width: 400px;" /></td>
	                  </tr>
	              </table>
	              <?php if ($checkApi) { ?>
	              <table cellpadding="5" cellspacing="5">
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_owner">Propriétaire Sellsy</label></th>
	                      <td>
	                      	<?php
	                      	if ($checkApi) {
	                      		$staffs = sellsyHelpers::get_staffs();

	                      		if (!empty($staffs)) {

                    		echo '<select id="woocommerce_sellsy_owner" name="woocommerce_sellsy_owner" style="width: 400px;">';

                    		foreach ($staffs as $id => $staff) {
                    			$checked = (get_option('woocommerce_sellsy_owner') == $id) ? 'selected="selected"' : '';
                    			echo '<option value="' . $id . '" ' . $checked . '>' . $staff . '</option>';
                    		}

                    		echo '</select>';
	                      		}
	                      	}
	                      	?>
	                      </td>
	                  </tr>
	              </table>
	              <?php } ?>


	              <h2>Rôles</h2>
	              <p>Choisissez les types de comptes Wordpress / WooCommerce dont vous souhaitez synchroniser les commandes</p>
	              <table cellpadding="5" cellspacing="5">
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_roles">Type de compte</label></th>
	                      <td>
				              <?php
							  global $wp_roles;
					          foreach ($wp_roles->roles as $name => $role)
					          {
						          $checked = in_array($name, $sync_roles) ? 'checked' : '';
						          echo '<label id="woocommerce_sellsy_api_roles_'.$name.'" class="mrg-r-10">';
						          	echo '<input type="checkbox" name="woocommerce_sellsy_roles[]" '.$checked.' id="woocommerce_sellsy_api_doctypes_'.$name.'" value="'.$name.'"> ' . $role['name'];
						          echo '</label>';
					          }
					          ?>   
	                      </td>
	                  </tr>
	              </table>


	              <h2>Documents</h2>
	              <?php if (!$checkApi) {
	              	echo '<div class="alert alert-info">Vous devez renseigner des tokens API valides pour accéder à cette rubrique.</div>';
	              }
	              ?>
	              <?php if ($checkApi) { ?>
	              <table cellpadding="5" cellspacing="5">
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_doctypes">Documents à créer sur Sellsy</label></th>
	                      <td>
	                      	<label id="woocommerce_sellsy_api_doctypes_order" class="mrg-r-10">
	                      		<input type="checkbox" name="woocommerce_sellsy_doctypes[]" <?php if (in_array('order', $doctypes)) { echo 'checked'; } ?> id="woocommerce_sellsy_api_doctypes_order" value="order"> Bon de commande
	                      	</label>
	                      	<label id="woocommerce_sellsy_api_doctypes_delivery" class="mrg-r-10">
	                      		<input type="checkbox" name="woocommerce_sellsy_doctypes[]" <?php if (in_array('delivery', $doctypes)) { echo 'checked'; } ?> id="woocommerce_sellsy_api_doctypes_delivery" value="delivery"> Bon de livraison
	                      	</label>
	                      	<label id="woocommerce_sellsy_api_doctypes_invoice" class="mrg-r-10">
	                      		<input type="checkbox" name="woocommerce_sellsy_doctypes[]" <?php if (in_array('invoice', $doctypes)) { echo 'checked'; } ?> id="woocommerce_sellsy_api_doctypes_invoice" value="invoice"> Facture
	                      	</label>
	                      </td>
	                  </tr>
	                  <?php if (in_array('invoice', $doctypes)) { ?>
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_send_invoice">Envoyer la facture par email au client</label></th>
	                      <td>
	                        <select id="woocommerce_sellsy_send_invoice" name="woocommerce_sellsy_send_invoice">
	                          <option <?php if (get_option('woocommerce_sellsy_send_invoice') == 'yes') { echo 'selected'; } ?> value="yes">Oui</option>
	                          <option <?php if (get_option('woocommerce_sellsy_send_invoice') == 'no') { echo 'selected'; } ?> value="no">Non</option>
	                        </select>
	                      </td>
	                  </tr>
	                  <?php } ?>
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_woo_order_status">Créer la commande dans Sellsy<br />dès son passage en statut</label></th>
	                      <td>
	                      	<select id="woocommerce_sellsy_woo_order_status" name="woocommerce_sellsy_woo_order_status">
	                      		<option <?php if (get_option('woocommerce_sellsy_woo_order_status') == 'completed') { echo 'selected="selected"'; } ?> value="completed">Terminé</option>
	                      		<option <?php if (get_option('woocommerce_sellsy_woo_order_status') == 'processing') { echo 'selected="selected"'; } ?> value="processing">En cours</option>
	                      		<option <?php if (get_option('woocommerce_sellsy_woo_order_status') == 'on-hold') { echo 'selected="selected"'; } ?> value="on-hold">En attente</option>
	                      	</select>
	                      </td>
	                  </tr>
	              </table>


	           		<?php if ($wooShippingOption !== 'disabled') { ?>
	              <h2>Synchronisation des transporteurs</h2>
	              <table cellpadding="5" cellspacing="5">
	              	<?php foreach ($shipping_methods as $code => $method) { ?>
	              	<?php if ($method->enabled !== 'yes') { continue; } ?>
	                <tr valign="top">
	                    <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_carrier_<?php echo $method->id; ?>"><?php echo $method->method_title; ?></label></th>
	                    <td>
	                    	<select id="woocommerce_sellsy_carrier_<?php echo $method->id; ?>" name="woocommerce_sellsy_carrier_<?php echo $method->id; ?>">
	                    		<option value="">Sélectionner</option>
	                    		<?php
	                    		foreach ($ssy_carriers as $id => $name) {

                  		$selected = get_option('woocommerce_sellsy_carrier_' . $method->id);

                  		$selected_id = !empty($selected) ? explode('|', $selected)[0] : false;


	                    			$checked = ($id == $selected_id) ? 'selected="selected"' : '';
	                    			echo '<option value="' . $id . '|' . $name . '" ' . $checked . '>' . $name . '</option>';
	                    		}
	                    		?>
	                    	</select>
	                    </td>
	                </tr>
	              	<?php } ?>
	              </table>
	           		<?php } ?>


	              <h2>Debug</h2>
	              <p>Pour être prévenu en cas d'erreur</p>
	              <table cellpadding="5" cellspacing="5">
	                  <tr valign="top">
	                      <th width="300" align="left" scope="row"><label for="woocommerce_sellsy_debug_email">Email</label></th>
	                      <td><input type="text" id="woocommerce_sellsy_debug_email" name="woocommerce_sellsy_debug_email" value="<?php echo get_option('woocommerce_sellsy_debug_email'); ?>" style="width: 400px;" /></td>
	                  </tr>
	              </table>

          <?php } ?>
	          </div>


	          <?php submit_button(); ?>
	      </form>
	  </div>
	  <?php
}
?>
