<?php
/*
Plugin Name: WooCommerce to Sellsy
Plugin URI: https://sellsy.fr/
Description: Automatisation du processus de vente Woocommerce - Sellsy.
Author: Sellsy
Version: 1.4
Author URI: https://sellsy.fr
*/


// @toDo
// Check crontab
// Produits virtuels >> Services Sellsy

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) )
	exit;


/**
 * Definitions
 *
 * @since 1.0
 */

define('WOOCOMMERCE_SELLSY_VERSION', '1.4');
define('WOOCOMMERCE_SELLSY_PLUGIN_DIR', WP_PLUGIN_DIR.'/'.dirname(plugin_basename(__FILE__)));
define('WOOCOMMERCE_SELLSY_PLUGIN_URL', WP_PLUGIN_URL.'/'.dirname(plugin_basename(__FILE__)));
define('WOOCOMMERCE_SELLSY_PLUGIN_NAME', 'woocommerce-to-sellsy');
define('WOOCOMMERCE_SELLSY_DEBUG', false);

define('SELLSY_API_CONSUMER_TOKEN',  get_option('woocommerce_sellsy_api_consumer_token'));
define('SELLSY_API_CONSUMER_SECRET', get_option('woocommerce_sellsy_api_consumer_secret'));
define('SELLSY_API_ACCESS_TOKEN', get_option('woocommerce_sellsy_api_access_token'));
define('SELLSY_API_ACCESS_SECRET', get_option('woocommerce_sellsy_api_access_secret'));


/**
 * Required Files
 * @since 1.0
 */

require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/libs/sellsy/sellsyconnect_curl.php');
require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/libs/sellsy/sellsytools.php');
require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/class/functions.php');

require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/settings.php');

require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/class/sellsy_helpers.php');
require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/class/sellsy_products.php');
require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/class/sellsy_thirds.php');
require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/class/sellsy_orders.php');

require_once(WOOCOMMERCE_SELLSY_PLUGIN_DIR . '/crons.php');


// Testing all plugins
/*
add_action( 'init', 'sellsy_testing');

function sellsy_testing() {
	// import_ssy_product_to_wc();
	// shippingBo_deliveries();
	// sellsyProducts::enable_ssy_send_to_woo();
	// sellsyProducts::import_ssy_product_to_wc();
	// sellsyProducts::check_ssy_products_in_wc();

	// $customer_id = '8018'; // 5840
	// sellsyThirds::checkThird($customer_id);

	// $order_id = '';
	// sellsyOrders::generate_sellsy_order($order_id);
	// import_wc_orders_to_ssy();
	// import_wc_thirds_to_ssy();
	// import_ssy_stocks_to_wc();
	// $taxes = sellsyHelpers::get_taxes();
	// pr($taxes); die();
}
*/


// Hook on WooCommerce account create
function woocommerce_sellsy_checkThird($user_id) {
	return sellsyThirds::checkThird($user_id);
}


// Hook when new user is created

function woocommerce_hook_newuser($user_id) {
  $fp = fopen(plugin_dir_path(__FILE__) . "hooks/files/user-$user_id.txt","wb");
  fwrite($fp, $user_id);
  fclose($fp);
}

add_action('user_register', 'woocommerce_hook_newuser', 10, 1);

//add_action('edit_user_profile_update', 'woocommerce_hook_newuser', 10, 1);



// Hook when new order is completed
function woocommerce_hook_order($order_id) {
  $fp = fopen(plugin_dir_path(__FILE__) . "hooks/files/order-$order_id.txt","wb");
  fwrite($fp, $order_id);
  fclose($fp);
}

add_action('woocommerce_order_status_' . get_option('woocommerce_sellsy_woo_order_status'), 'woocommerce_hook_order', 10, 1);


function woocommerce_sellsy_log($log) {
  $fp = fopen(plugin_dir_path(__FILE__) . "logs/" . date('Y-m-d_His') . ".txt","wb");
  fwrite($fp, "<pre>" . print_r($log,true) . "</pre>");
  fclose($fp);
}
